<?php // PLUGIN_TITLE: Rebuild Search Index
/**************************************************************************
 *                                                                        *
 *    4images - A Web Based Image Gallery Management System               *
 *    ----------------------------------------------------------------    *
 *                                                                        *
 *             File: rebuild_searchindex.php                              *
 *        Copyright: (C) 2002 Jan Sorgalla                                *
 *            Email: jan@4homepages.de                                    *
 *              Web: http://www.4homepages.de                             *
 *    Scriptversion: 1.7                                                  *
 *                                                                        *
 *    Never released without support from: Nicky (http://www.nicky.net)   *
 *                                                                        *
 **************************************************************************
 *                                                                        *
 *    Dieses Script ist KEINE Freeware. Bitte lesen Sie die Lizenz-       *
 *    bedingungen (Lizenz.txt) fr weitere Informationen.                 *
 *    ---------------------------------------------------------------     *
 *    This script is NOT freeware! Please read the Copyright Notice       *
 *    (Licence.txt) for further information.                              *
 *                                                                        *
 *************************************************************************/

$nozip = 1;
define('IN_CP', 1);
$root_path = (eregi("\/plugins\/", $PHP_SELF)) ? "./../../" : "./../";
define('ROOT_PATH', $root_path);
require(ROOT_PATH.'admin/admin_global.php');
include(ROOT_PATH.'includes/search_utils.php');

if ($action == "") {
  $action = "intro";
}

if (!defined('MIN_SEARCH_KEYWORD_LENGTH')) {
  define('MIN_SEARCH_KEYWORD_LENGTH', 3);
}
if (!defined('MAX_SEARCH_KEYWORD_LENGTH')) {
  define('MAX_SEARCH_KEYWORD_LENGTH', 25);
}

function next_step($batchstart, $batchsize, $autoredirect = 0) {
  global $site_sess;
  $page = $site_sess->url("rebuild_searchindex.php?action=buildsearchindex&batchstart=".$batchstart."&batchsize=".$batchsize."&autoredirect=".$autoredirect);
if ($autoredirect) {
?>
<script language="javascript">
myvar = "";
timeout = 15;
function dorefresh() {
  window.status="Redirecting"+myvar;
  myvar = myvar + " .";
  timerID = setTimeout("dorefresh();", 100);
  if (timeout > 0) {
    timeout -= 1;
  }
  else {
    clearTimeout(timerID);
    window.status="";
    window.location="<?php echo $page; ?>";
  }
}
dorefresh();
</script>
<?php
}
?>
<br />
<table border="0" cellspacing="0" cellpadding="1">
  <tr>
    <td class="tableseparator">
      <table width="100%" border="0" cellspacing="0" cellpadding="3">
        <tr>
          <td class="tablerow2" align="center">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="<?php echo $page; ?>"><b>Click here to continue</b></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<br />
<?php
}

show_admin_header();

if ($action == "emptyindex") {
  $site_db->query("DELETE FROM ".WORDMATCH_TABLE);
  $site_db->query("DELETE FROM ".WORDLIST_TABLE);
  echo "<p><b>    !</b></p>";
  $action = "intro";
}

if ($action == "intro") {
?>
  <script language="JavaScript">
  <!--
  function ConfirmEmptySearchindex() {
    if (confirm('           ')) {
      window.location = "<?php echo $site_sess->url("rebuild_searchindex.php?action=emptyindex"); ?>";
    }
  }
  //-->
  </script>
<?php
  show_form_header("rebuild_searchindex.php", "buildsearchindex");
  show_table_header("   ", 2);
  show_input_row("      ", "batchsize", 50);
  show_input_row("   ", "batchstart", 0);
  show_radio_row("        ", "autoredirect", 1);
  show_form_footer($lang['submit'], $lang['reset'], 2);
  echo "<p align=\"center\"><b>(  )";
  echo "<p align=\"center\"><b>             <br />            ";
  echo "<p align=\"center\"><b>------->       ,     . ";
  echo "<a href=\"javascript:ConfirmEmptySearchindex()\">   !</a></b></p>";
}

if ($action == "buildsearchindex") {
  if (isset($HTTP_GET_VARS['batchstart']) || isset($HTTP_POST_VARS['batchstart'])) {
    $batchstart = (isset($HTTP_GET_VARS['batchstart'])) ? intval($HTTP_GET_VARS['batchstart']) : intval($HTTP_POST_VARS['batchstart']);
  }
  else {
    $batchstart = 0;
  }

  if (isset($HTTP_GET_VARS['batchsize']) || isset($HTTP_POST_VARS['batchsize'])) {
    $batchsize = (isset($HTTP_GET_VARS['batchsize'])) ? intval($HTTP_GET_VARS['batchsize']) : intval($HTTP_POST_VARS['batchsize']);
    if (!$batchsize) {
      $batchsize = 25;
    }
  }
  else {
    $batchsize = 50;
  }

  if (isset($HTTP_GET_VARS['autoredirect']) || isset($HTTP_POST_VARS['autoredirect'])) {
    $autoredirect = (isset($HTTP_GET_VARS['autoredirect'])) ? intval($HTTP_GET_VARS['autoredirect']) : intval($HTTP_POST_VARS['autoredirect']);
  }
  else {
    $autoredirect = 0;
  }

  $sql = "SELECT MAX(image_id) as max 
          FROM ".IMAGES_TABLE;
  $row = $site_db->query_firstrow($sql);
  $max = (isset($row['max'])) ? $row['max'] : 0;

  $batchend = $batchstart + $batchsize - 1;
  if ($batchend >= $max) {
    $batchend = $max;
  }

  echo "<b>      ".$batchstart."    ".$batchend.":</b><p>";

  $sql = "SELECT * 
          FROM ".IMAGES_TABLE." 
          WHERE image_id 
          BETWEEN $batchstart AND $batchend";
  $result = $site_db->query($sql);

  while ($row = $site_db->fetch_array($result)) {
    echo "  <b>".$row['image_name']."</b>, ID ".$row['image_id']." ...";
    flush();
    @set_time_limit(90);
    $search_words = array();
    foreach ($search_match_fields as $image_column => $match_column) {
      if (isset($row[$image_column])) {
        $search_words[$image_column] = $row[$image_column];
      }
    }
    add_searchwords($row['image_id'], $search_words);
    echo " <b></b><br />\n";
  }
  if ($batchend < $max) {
    next_step($batchend + 1, $batchsize, $autoredirect);
  }
  else {
    echo "<p><b>      !</b><p>\n";
    show_text_link("Back", "rebuild_searchindex.php");
  }
}

show_admin_footer();
?>
